﻿using System;
using System.Windows.Forms;
using System.Drawing;//Rectangle 사용을 위해 
using System.Runtime.InteropServices; // Marshal를 쓰기위해
using DirectShowLib; // 다이렉트쇼 사용


namespace DSTest_2
{
    public partial class Form1 : Form
    {

        const int WM_GRAPHNOTIFY = 0x00008001;
        //다이렉트쇼용 그래프와 콘트롤 선언
        IGraphBuilder pGraphBuilder = null;
        IMediaControl pMediaControl = null;
        
        //윈도우 선언
        IVideoWindow pVideoWindow = null;


        public Form1()
        {
            InitializeComponent();
   
        }

        private void button1_Click(object sender, System.EventArgs e)
        {
            Play();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            CloseInterface();
        }
        

        private void Play()
        {
            //인터넷에서 다운 받으면서 바로 재생시키기
            SetupGraph(panel1, "test.wmv");

            //동영상 플레이 하기
            pMediaControl.Run();
        }


        private void SetupGraph(Control hWin, string filename)
        {
            //새로운 필터그래프 대응
            pGraphBuilder = (IGraphBuilder)new FilterGraph();
            //필터그래프에 콘트롤 붙이기
            pMediaControl = (IMediaControl)pGraphBuilder;
            
            //윈도우 붙이기
            pVideoWindow = (IVideoWindow)pGraphBuilder;



            //콘트롤에 동영상 읽어오기
            pMediaControl.RenderFile(filename);
            //pGraphBuilder.RenderFile(filename, null);

            //판넬에서 재생하기
            pVideoWindow.put_Owner(hWin.Handle);
            pVideoWindow.put_WindowStyle(WindowStyle.Child | WindowStyle.ClipSiblings);

            Rectangle rect = panel1.ClientRectangle;

            pVideoWindow.SetWindowPosition(0, 0, rect.Right, rect.Bottom);

               
        }
          

        #region 그래프와 프로그램 종료
        private void CloseInterface()
        {

            //그래프와 콘트롤 해제

            if (pMediaControl != null)
            {
                pMediaControl.StopWhenReady();
            }

            if (pVideoWindow != null)
            {
                pVideoWindow.put_Visible(OABool.False);
                pVideoWindow.put_Owner(IntPtr.Zero);
            }

           
            Marshal.ReleaseComObject(pGraphBuilder);
            pGraphBuilder = null;
            Marshal.ReleaseComObject(pMediaControl);
            pMediaControl = null;
            
            Marshal.ReleaseComObject(pVideoWindow);
            pVideoWindow = null;

            this.Close();
        }
        #endregion 

       
        
    }
}
